package ch.ivyteam.test;

import ch.ivyteam.di.restricted.DiCore;
import ch.ivyteam.ivy.bpm.engine.restricted.IBpmEngine;
import ch.ivyteam.ivy.bpm.engine.restricted.history.IElementExecutionHistory;
import ch.ivyteam.ivy.bpm.engine.restricted.history.IElementHistory;
import ch.ivyteam.ivy.bpm.engine.restricted.history.IElementHistoryListener;
import ch.ivyteam.ivy.bpm.engine.restricted.history.IElementRequestHistory;
import ch.ivyteam.ivy.environment.Ivy;
import ch.ivyteam.ivy.process.model.value.PID;
import ch.ivyteam.log.Logger;
import exec.listener.Data;

@SuppressWarnings("restriction")
public class ExecListener {

	public static void install()
	{
		IBpmEngine engine = DiCore.getGlobalInjector().getInstance(IBpmEngine.class);
		engine.getHistory().addElementHistoryListener(new LoggingListener(Ivy.log()));
	}
	
	private static class LoggingListener implements IElementHistoryListener
	{
		private Logger logger;

		public LoggingListener(Logger logger) {
			this.logger = logger;
		}
		
		@Override
		public void elementExecutionHistoryAdded(IElementExecutionHistory executionHistory) {
			PID pid = executionHistory.getElementRequestHistory().getElementHistory().getProcessElementId();
			logger.info("executing element pid: "+pid);
			
			Object in = executionHistory.getData().getAttributeValue("in");
			if (in instanceof Data)
			{
				Data data = (Data)in;
				logger.info(data);
			}
		}

		@Override
		public void elementRequestHistoryAdded(
				IElementRequestHistory requestHistory) {
			//nop
		}

		@Override
		public void elementHistoryAdded(IElementHistory elementHistory) {
			//nop
		}

		@Override
		public void historyCleared() {
			//nop
		}
		
	}
	
}
